

window.addEventListener("load",function() {initAutoCopyStatus();} ,false);
window.addEventListener("focus",function() {resetAutoCopyStatus();} ,false);


function autocopyContextHide() {
	var cm = gContextMenu;
	var AutocopyFirebirdcontextmenuitem = document.getElementById('autocopy-firebirdcontextmenuitem');


	if(autocopyPrefs.getBoolPref("optContextMenuItem")){
		AutocopyFirebirdcontextmenuitem.hidden = ( cm.onImage || cm.onLink || cm.onTextInput );
		//|| cm.onLink || cm.onImage || cm.onTextInput );
	}
	else{
	    AutocopyFirebirdcontextmenuitem.hidden = true;
	}
}


function setAutoCopyStatus()
{
	if(autocopyPrefs.getBoolPref("optStatusBar")){
		var autocopy = document.getElementById('autocopy-status');
		var tooltip = document.getElementById('autocopy-tooltip-value');

		if(autocopy)
		{
			autocopy.setAttribute("status", enabled);	
		    	var strings = document.getElementById("autocopyStrings");
			tooltip.setAttribute("value", strings.getString("statusbar-tooltip-enabled"));
		}
	}

}



function initAutoCopyStatus() 
{
        initPreferences();
	
	document.getElementById("cmd_selectAll").setAttribute("oncommand", "goDoCommand('cmd_selectAll'); AutocopySelectAll();");


    	var strings = document.getElementById("autocopyStrings");

	var autocopyLocalizationPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.{0FED7D55-65D4-47b6-A6DE-9A4ADB55355F}.");
	var autocopylocaledescription = strings.getString("autocopy-description");
	var str = Components.classes[ "@mozilla.org/supports-string;1" ].createInstance( Components.interfaces.nsISupportsString );
	str.data = autocopylocaledescription;
	autocopyLocalizationPrefs.setComplexValue( "description", Components.interfaces.nsISupportsString, str );
  

	var autocopyStatusBarButton = document.getElementById('autocopy-status');
	var autocopyStatusBarButtonTooltip = document.getElementById('autocopy-tooltip-value');
	if(autocopyStatusBarButton)
	{

		if(autocopyPrefs.getBoolPref("optStatusBar")){
        	    autocopyStatusBarButton.setAttribute("hidden", false);
        	}
        	else{
        	    autocopyStatusBarButton.setAttribute("hidden", true);
        	}
	

		if (autocopyPrefs.getIntPref("StatusBarState") == 0)
	        {
			 if(autocopyPrefs.getBoolPref("optStatusBar")){
		                 autocopyStatusBarButton.setAttribute("status", "disabled");
	        	         autocopyStatusBarButtonTooltip.setAttribute("value", strings.getString("statusbar-tooltip-disabled"));
	        	 }
		}
		else
		{
			 if(autocopyPrefs.getBoolPref("optStatusBar")){
	                 	autocopyStatusBarButton.setAttribute("status", "enabled");
	                 	autocopyStatusBarButtonTooltip.setAttribute("value", strings.getString("statusbar-tooltip-enabled"));
			 }
		}

	}




	var AutocopyFirebirdmenuitem = document.getElementById('autocopy-firebirdmenuitem');
	var AutocopyFirebirdmenuitemseparator = document.getElementById('autocopy-firebirdmenuitemseparator');
	if(AutocopyFirebirdmenuitem)
	{
		if (autocopyPrefs.getIntPref("StatusBarState") == 0)
	        {
	                 AutocopyFirebirdmenuitem.setAttribute("checked", false);
		}
		else
		{
	                 AutocopyFirebirdmenuitem.setAttribute("checked", true);
		}

	        if(autocopyPrefs.getBoolPref("optEditMenuItem")){
		    AutocopyFirebirdmenuitemseparator.setAttribute("hidden", false);
	            AutocopyFirebirdmenuitem.setAttribute("hidden", false);
	        }
	        else{
		    AutocopyFirebirdmenuitemseparator.setAttribute("hidden", true);
	            AutocopyFirebirdmenuitem.setAttribute("hidden", true);
	        }
	}

	var AutocopyFirebirdcontextmenuitem = document.getElementById('autocopy-firebirdcontextmenuitem');
	if(AutocopyFirebirdcontextmenuitem)
	{
		if (autocopyPrefs.getIntPref("StatusBarState") == 0)
	        {
			 AutocopyFirebirdcontextmenuitem.setAttribute("checked", false);
		}
		else
		{
			 AutocopyFirebirdcontextmenuitem.setAttribute("checked", true);
		}
		
		if(document.getElementById("contentAreaContextMenu"))
		{
			document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",autocopyContextHide,false);
	        }	
	}


	var Autocopykeytoggleautocopyenabled = null;
	if(document.getElementById('firebirdkey-toggle-autocopyenabled'))
		Autocopykeytoggleautocopyenabled = document.getElementById('firebirdkey-toggle-autocopyenabled');
	if(document.getElementById('mozillakey-toggle-autocopyenabled'))
		Autocopykeytoggleautocopyenabled = document.getElementById('mozillakey-toggle-autocopyenabled');
	if(document.getElementById('thunderbirdkey-toggle-autocopyenabled'))
		Autocopykeytoggleautocopyenabled = document.getElementById('thunderbirdkey-toggle-autocopyenabled');

	if(Autocopykeytoggleautocopyenabled)
	{
	        if(autocopyPrefs.getBoolPref("optKeyboardShortcutEnabled")){
	    
	            var optModifiers = "";
	            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyAccel"))
	                optModifiers = optModifiers + ",accel";
	            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyMeta"))
	                optModifiers = optModifiers + ",meta";
	            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyCtrl"))
	                optModifiers = optModifiers + ",control";
	            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyShift"))
	                optModifiers = optModifiers + ",shift";
	            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyAlt"))
	                optModifiers = optModifiers + ",alt";
	                
	            optModifiers.replace(/^\,/,"");
	        
	            var optKey = autocopyPrefs.getCharPref("optKeyboardShortcutKey");
	            if(optKey.match(/^[A-Z]$/i)){
	                Autocopykeytoggleautocopyenabled.setAttribute("key", optKey);
	                Autocopykeytoggleautocopyenabled.setAttribute("keycode", "");
	            }
	            else{
	                Autocopykeytoggleautocopyenabled.setAttribute("key", "");
	                Autocopykeytoggleautocopyenabled.setAttribute("keycode", optKey);
	            }
	            
	            Autocopykeytoggleautocopyenabled.setAttribute("modifiers", optModifiers);
	            Autocopykeytoggleautocopyenabled.setAttribute("disabled", false);
	        }
	        else{
	            Autocopykeytoggleautocopyenabled.setAttribute("disabled", true);
	        }
	}	
}



function resetAutoCopyStatus()
{
    initAutoCopyStatus()
}




function initPreferences(){

	if (!autocopyPrefs.prefHasUserValue("StatusBarState"))
		autocopyPrefs.setIntPref("StatusBarState", 1)

	if (!autocopyPrefs.prefHasUserValue("optPasteOnMiddleClick"))
		autocopyPrefs.setBoolPref("optPasteOnMiddleClick", true);

	if (!autocopyPrefs.prefHasUserValue("optDeselectAfterCopy"))
	{
		if(navigator.vendor.match(/Thunderbird/i))
		{
			autocopyPrefs.setBoolPref("optDeselectAfterCopy", false);
		}
		else
		{
			autocopyPrefs.setBoolPref("optDeselectAfterCopy", true);
		}
	}


	if (!autocopyPrefs.prefHasUserValue("optStatusBar"))
		autocopyPrefs.setBoolPref("optStatusBar", true);
	if (!autocopyPrefs.prefHasUserValue("optEditMenuItem"))
		autocopyPrefs.setBoolPref("optEditMenuItem", true);
	if (!autocopyPrefs.prefHasUserValue("optContextMenuItem"))
		autocopyPrefs.setBoolPref("optContextMenuItem", false);
	if (!autocopyPrefs.prefHasUserValue("optEnableInTextBoxes"))
		autocopyPrefs.setBoolPref("optEnableInTextBoxes", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutEnabled"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutEnabled", true);

	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyAccel"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyAccel", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyMeta"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyMeta", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyCtrl"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyCtrl", true);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyShift"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyShift", true);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyAlt"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyAlt", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKey"))
		autocopyPrefs.setCharPref("optKeyboardShortcutKey", "C");
}




function switchautocopystatusstate()
{
        if (autocopyPrefs.getIntPref("StatusBarState") == 0)
        {
		autocopyPrefs.setIntPref("StatusBarState", 1);
        }
        else
        {
		autocopyPrefs.setIntPref("StatusBarState", 0);
        }
        initAutoCopyStatus();
}



// prefs
var autocopyPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("autocopy.");

if (!autocopyPrefs.prefHasUserValue("StatusBarState"))
	autocopyPrefs.setIntPref("StatusBarState", 1)


window.onmouseup = autocopyOnMouseUp;
window.onkeyup = onKeyUpCheck;


function onKeyUpCheck(e)
{
	if(e.keyCode == e.DOM_VK_A && e.ctrlKey)
	{
		autocopyOnMouseUp(e);
	}
}


function autocopyOnMouseUp(e){
   
   var targetclassname = e.target.toString();
   if(autocopyPrefs.getIntPref("StatusBarState") == 1){
	if (!targetclassname.match(/object XUL/i))
	{
		if(!targetclassname.match(/SelectElement|OptionElement/i))
		{
			if(!targetclassname.match(/InputElement|TextAreaElement/i) || autocopyPrefs.getBoolPref("optEnableInTextBoxes"))
			{
				goDoCommand('cmd_copy');
				if(autocopyPrefs.getBoolPref("optDeselectAfterCopy"))
				{
					goDoCommand('cmd_selectNone');
				}
			}
		}
	}
   }

   if(autocopyPrefs.getBoolPref("optPasteOnMiddleClick"))
   {

	if(e.button == 1)
	{
		var doPaste = false;
		if(e.target.toString().match(/HTML.*Element/i))
		{
			if(!e.target.toString().match(/HTMLAnchorElement/i))
			{
				doPaste = true;
			}
			if(e.target.toString().match(/HTMLImageElement/i))
			{
				if(e.target.src.match(/chrome\:\/\/.*autoscroll/i))
				{
					doPaste = true;
				}
			}
		}

		if(e.target.inputField)
		{
			if(e.target.inputField.toString().match(/InputElement|TextAreaElement/i))
			{
				doPaste = true;
			}
		}

		if(e.target.mTextbox)
		{
			if(e.target.mTextbox.inputField)
			{
				if(e.target.mTextbox.inputField.toString().match(/InputElement|TextAreaElement/i))
				{
					doPaste = true;
				}
			}
		}

		if(doPaste)
		{
			goDoCommand('cmd_paste');
		}
	}
    }
}


function AutocopySelectAll(){
   if(autocopyPrefs.getIntPref("StatusBarState") == 1)
   {
	goDoCommand('cmd_copy');
	if(autocopyPrefs.getBoolPref("optDeselectAfterCopy"))
	{
		goDoCommand('cmd_selectNone');
	}
   }
}



